--
-- procedura che incrementa selettivamente lo stipendio dei dipendenti dei dipartimenti
-- argomenti
-- CONTEGGIODIPART : numero dei dipartimenti usato come soglia
-- SOGLIADIPENDENTI: numero dei dipendenti
-- PRIMO: valore per aggiornare nel caso 1
-- SECONDO valore per aggiornmare nel caso 2
--
-- logica: si stabilisce quanti sono i dipartimenti che hanno un numero di dipendenti maggiore di SOGLIADIPENDENTI
--         caso 1: se tale NUMERO è maggiore di CONTEGGIODIPART, si esegue l'aggiornamento usando il valore PRIMO
--         caso 2: se tale NUMERO è minore o uguale a CONTEGGIODIPART, si usa il valore SECONDO
--
--         l'aggiornamento avviene chiamando la STORED PROCEDURE aggiornastipendio

drop procedure if exists ModificastipendiSelettiva;
delimiter $$
CREATE PROCEDURE ModificastipendiSelettiva (IN CONTEGGIODIPART INT, IN SOGLIADIPENDENTI INT,  IN PRIMO INT, IN SECONDO INT)
BEGIN
declare NUMERO INT;
set NUMERO = (select count(*) from DIPART D where (select count(*) from DIPENDENTI DD where D.NUM_DIPART=DD.NUM_DIPART ) > SOGLIADIPENDENTI);
IF NUMERO > CONTEGGIODIPART
THEN
	call aggiornastipendio(PRIMO);
else 
	call aggiornastipendio(SECONDO);
END IF;
END $$
delimiter ;