--
-- il trigger limitastipendiobis limita gli aggiornamenti allo stipendio
-- impedendo che l'aggiornamento dia origine a uno stipendio superiore a quello massimo
--
drop trigger if exists limitastipendiobis;
delimiter //

create trigger limitastipendiobis BEFORE UPDATE on dipendenti
for each row 
begin 
	declare massimo INT;
    select max(stipendio) from dipendenti into massimo;
     if new.stipendio > massimo THEN
        set new.stipendio = old.stipendio;
     end if;
end;//
delimiter ;
--
-- la query che segue elenca, per ogni dipendente, lo stipendio del suo superiore (denominato CAPOSTIPENDIO) 
-- se tale stipendo è superiore a quello del dipendente 
select CAPO.stipendio as capostipendio, D1.stipendio from DIPENDENTI D1 join DIPENDENTI CAPO on D1.SUP=CAPO.MATRICOLA
where D1.stipendio < CAPO.stipendio;
--
-- 
-- il trigger limitastipendiosuperiore impedisce che un aumento allo stipendio di un dipendente
-- faccia sì che il nuovo stipendio sia maggiore di quello del suo superiore
-- in tal caso, lo stipendio rimane invariato
drop trigger if exists limitastipendiosuperiore;
delimiter //
create trigger limitastipendiosuperiore BEFORE UPDATE on dipendenti
for each row 
begin 
      declare STIPENDIOCAPO INT;
      set STIPENDIOCAPO = (select CAPO.stipendio from DIPENDENTI D1 join DIPENDENTI CAPO on D1.SUP=CAPO.MATRICOLA);
     if new.stipendio > STIPENDIOCAPO 
     THEN
        set new.stipendio = old.stipendio;
     end if;
end;//
delimiter ;  